package com.ep26.chatapp;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.provider.BaseColumns;
import android.util.Log;

/** Helper to the database, manages versions and creation */
public class ContactDataSQLHelper extends SQLiteOpenHelper {
	private static final String DATABASE_NAME = "contacts.db";
	private static final int DATABASE_VERSION = 1;

	// Table name
	public static final String TABLE = "contacts";

	// Columns
	public static final String NAME = "name";
	public static final String IPADDR = "ipaddress";
	public static final String HISTORY = "history";
	public static final String PORT = "port";

	public ContactDataSQLHelper(Context context) {
		super(context, DATABASE_NAME, null, DATABASE_VERSION);
	}

	@Override
	public void onCreate(SQLiteDatabase db) {
		String sql = "create table " + TABLE + "( " + BaseColumns._ID
				+ " integer primary key autoincrement, " // 0
				+ NAME + " text, " // 1
				+ HISTORY + " text, " // 2
				+ IPADDR + " text unique not null, " // 3
				+ PORT + " text not null);"; // 4
		Log.d("EventsData", "onCreate: " + sql);
		db.execSQL(sql);
	}

	@Override
	public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
		if (oldVersion < newVersion) {
			String sql = "drop table if exists " + TABLE;
			db.execSQL(sql);
			onCreate(db);
		}

	}

}