package com.ep26.chatapp;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;

public class ContactsAdapter extends ArrayAdapter<Contact> {

	int resource;
	Context context;

	// Initialize adapter
	public ContactsAdapter(Context context, int textViewResourceId) {
		super(context, textViewResourceId);
		this.resource = textViewResourceId;
		this.context = context;
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {
		LinearLayout contactView;

		// Get the current Contact object
		Contact contact = getItem(position);

		// Inflate the view
		if (convertView == null) {
			contactView = new LinearLayout(getContext());
			String inflater = Context.LAYOUT_INFLATER_SERVICE;
			LayoutInflater vi;
			vi = (LayoutInflater) getContext().getSystemService(inflater);
			vi.inflate(resource, contactView, true);
		} else {
			contactView = (LinearLayout) convertView;
		}
		// Get the text boxes from the listitem.xml file
		TextView contactName = (TextView) contactView
				.findViewById(R.id.contact_name_list_entry);
		TextView contactAddress = (TextView) contactView
				.findViewById(R.id.contact_ip_list_entry);
		ImageView onlineIcon = (ImageView) contactView
				.findViewById(R.id.ImageView02);
		ImageView startedIcon = (ImageView) contactView
				.findViewById(R.id.ImageView01);
		// Assign the appropriate data from our alert object above
		contactName.setText(contact.name);
		contactAddress.setText(contact.address + ":" + contact.port);

		// Set chat bubble icon for already started conversations
		if (contact.chatStarted) {
			startedIcon.setImageResource(R.drawable.bx_chat);
		} else {
			startedIcon.setImageResource(R.drawable.kitty);
		}
		// Set green dot icon for online contacts
		if (contact.isAlive()) {
			onlineIcon.setImageResource(R.drawable.online);
		} else {
			onlineIcon.setImageResource(R.drawable.offline);
		}

		return contactView;
	}
}
