package com.ep26.chatapp;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;

import android.os.Handler;
import android.os.Message;
import android.util.Log;

public class UDPServerThread extends Thread {

	static final int port = 44446;
	DatagramSocket socket = null;

	String receivedString;
	static String openWindowIp;
	static Handler handler;
	Handler serviceHandler;
	byte[] buffer = new byte[8192];

	DatagramPacket packet = new DatagramPacket(buffer, buffer.length);

	public static void setHandler(Handler h) {
		handler = h;
	}

	public void run() {

		try {
			socket = new DatagramSocket(port);
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(-1);
		}

		while (true) {
			try {
				socket.receive(packet);

				// this is always 10.0.2.2 if using the emulator
				InetAddress ipAddr = packet.getAddress();
				String packetsIp = ipAddr.getHostAddress();

				// decode the received datagram bytes into a String
				receivedString = new String(buffer, 0, packet.getLength(),
						"UTF-8");

				Message msg = Message.obtain(handler, 0,
						(Object) receivedString);

				// if the incoming packet is from the same IP as the one we
				// currently have an open conversation with, then just display
				// it normally
				// if only IPs had normal values that would work!
				if (handler != null && packetsIp.equals(openWindowIp)) {
					handler.sendMessage(msg);
				} else {
					// otherwise create a notification about the incoming
					// chat
					// lookup the IP to see if we know the user, otherwise
					// add them
					String remotePort = Integer.toString(packet.getPort());

					String contactName = ContactsActivity
							.getNameFromDb(packetsIp);
					if (contactName == null) {
						contactName = packetsIp;

						ContactsActivity.addContact(new Contact(contactName,
								packetsIp, remotePort));
					}
					Message msg2 = Message.obtain(serviceHandler, 0,
							(Object) new MessageToService(receivedString,
									contactName, packetsIp, remotePort));
					serviceHandler.sendMessage(msg2);

				}

			} catch (IOException e) {
				Log.d("run", "", e.getCause());
			}
		}
	}

	public static void setRemoteAddress(String contactIP) {
		openWindowIp = contactIP;
	}

}
